function Draw()
{
	var visib = true;

    // A reference to the canvas element
	canvas = null;
    // A reference to the 2D context of the canvas element
    this.context2D = null;

    // A reference to the in-memory canvas used as a back buffer
    this.backBuffer = null;
    // A reference to the backbuffer 2D context
    this.backBufferContext2D = null;

	// Initialises this object
	// @return A reference to the initialised object
    this.startupDraw = function()
    {
        // set the global pointer to reference this object
        g_GameObjectManager = this;
		
		document.onkeydown = function(event){keyDown(event);}
        document.onkeyup = function(event){keyUp(event);}
		
		document.onmousedown = function(event){mouseDown(event, 0, 0);}
		document.onmouseup = function(event){mouseUp(event, 0, 0);}

        // get references to the canvas elements and their 2D contexts
		canvas = document.getElementById('canvas');
		canvas.width = screenX;
		canvas.height = screenY;
        this.backBufferContext2D = canvas.getContext('2d');

//		canvas.touchstart = function(event){touchDown(event);}
//		canvas.touchend = function(event){touchUp(event);}
		document.ontouchstart = function(event){touchDown(event);}
		document.ontouchend = function(event){touchUp(event);}

//		canvas.addEventListener('touchend', mouseUp, false);
		
//        this.context2D = canvas.getContext('2d');
//        this.backBuffer = document.createElement('canvas');
//        this.backBuffer.width = canvas.width;
//        this.backBuffer.height = canvas.height;
//        this.backBufferContext2D = this.backBuffer.getContext('2d');
        
		this.backBufferContext2D.textBaseline = "middle";
		this.backBufferContext2D.textAlign = "center";
		
        // use setInterval to call the draw function
        setInterval(function(){g_GameObjectManager.draw();}, SECONDS_BETWEEN_FRAMES);
        
        return this;
    }
    
	
    /*
        The render loop
    */
	
    this.draw = function ()
    {    
		if (keyAbort) {if (keySlow) Move();} else
			Move();
		
		this.backBufferContext2D.textBaseline = "middle";
		this.backBufferContext2D.textAlign = "center";
		tableX = tableXcore + shake.x;
		
        // clear the drawing contexts
//        this.backBufferContext2D.clearRect(0, 0, this.backBuffer.width, this.backBuffer.height);
        this.backBufferContext2D.clearRect(0, 0, canvas.width, canvas.height);

//		console.log("GameMode: " + gameMode);
		
	
		if (gameMode == 22) { //LOADING
//			console.log("gamemode 22, loadTimer: " + loadTimer);
			this.backBufferContext2D.fillStyle = "Black";
			this.backBufferContext2D.font = "20px Arial";
 				this.backBufferContext2D.drawImage(imgMENULOAD, 0,	0);
				this.backBufferContext2D.drawImage(imgLOADSPOT,	0,	0,
										   297 * (loadCount/loadN),		80,
										   241,	343,
										   297 * (loadCount/loadN),		80);

				
        }
		else if (portrait != 1) {
            switch (iDevice){
                case 0: this.backBufferContext2D.drawImage(imgROTATE, screenX2 - 125,	screenY2 - 130); break;
                case 1: this.backBufferContext2D.drawImage(imgROTATE, screenX2 - 150,	screenY2 - 142); break;
                case 2: this.backBufferContext2D.drawImage(imgROTATE, screenX2 - 125,	screenY2 - 150); break;
            }
                
            }
        else
		{

		this.backBufferContext2D.save(); //GLOBAL
//			if (portrait == 2) {
//				this.backBufferContext2D.rotate(-PI/2);
//				this.backBufferContext2D.translate(-screenX, 0);
//			}
/* 		this.backBufferContext2D.save(); //GLOBAL ROTATED */

		this.backBufferContext2D.drawImage(imgBG, 0,	0);

		this.backBufferContext2D.globalAlpha = 1;

		//draw panel
		this.backBufferContext2D.translate(tableX, tableY);


		// draw animated & still plates
		for (var a=0; a<2; a++)
		{
			this.backBufferContext2D.save();		
				for (var y=0; y < AY; y++) {
					for (var x=1; x < AX; x+=2) {if (field[y][x] && !table[y][x][3]) this.drawPlate(y, x, a); this.backBufferContext2D.translate(plateX, 0);}
					this.backBufferContext2D.translate(-plateX * (AX-4) + plateX2, plateX - plateYfix);
					y++;
					for (var x=0; x < AX; x+=2) {if (field[y][x] && !table[y][x][3]) this.drawPlate(y, x, a); this.backBufferContext2D.translate(plateX, 0);}
					this.backBufferContext2D.translate(-plateX * (AX-5) - plateX2, plateX - plateYfix);
					
				}
			this.backBufferContext2D.restore();
			
			if (!a)	this.backBufferContext2D.drawImage(imgBGTOP, panelX,	panelY - 152);		
		}
		
		this.backBufferContext2D.restore(); //GLOBAL

		//draw animations

		this.backBufferContext2D.save(); //GLOBAL
		this.backBufferContext2D.translate(tableX, tableY);

		for (var y=0; y < AY; y++) {
			for (var x=1; x < AX; x+=2) { if (table[y][x][3]) this.drawAnim(y, x);  this.backBufferContext2D.translate(plateX, 0);}
			this.backBufferContext2D.translate(-plateX * (AX-4) + plateX2, plateX - plateYfix);
			y++;
			for (var x=0; x < AX; x+=2) { if (table[y][x][3]) this.drawAnim(y, x);  this.backBufferContext2D.translate(plateX, 0);}
			this.backBufferContext2D.translate(-plateX * (AX-5) - plateX2, plateX - plateYfix);
		}

		
		this.backBufferContext2D.restore();

				
		
		//draw timer
		this.backBufferContext2D.translate(tim.x + tim.shakeX, tim.y);
        this.backBufferContext2D.drawImage(imgTIMER, 0,	0);

        this.backBufferContext2D.save();
        this.backBufferContext2D.translate(tim.mid, tim.mid);
        if      (level > 8) this.backBufferContext2D.rotate(PI2 * 0.75 * (1 - (tim.h1) / tim.h1Max) );
        else if (level > 4) this.backBufferContext2D.rotate(PI2 * 0.8333333 * (1 - (tim.h1) / tim.h1Max));
        else                this.backBufferContext2D.rotate(-PI2 * (tim.h1) / tim.h1Max);
            
        this.backBufferContext2D.translate(-tim.mid, -tim.mid);
        this.backBufferContext2D.drawImage(imgTIMERH1, 0,	0);
        this.backBufferContext2D.restore();
            
        this.backBufferContext2D.translate(-tim.x - tim.shakeX, -tim.y);

        //draw level progress board
		if (level < 13) {
			this.backBufferContext2D.drawImage(imgLEVEL1, levelX,	levelY);

			if (levelP) this.backBufferContext2D.drawImage(imgLEVEL2,	0,		levelH - levelP,
																   levelW,		levelP,
																   levelX + 60,	levelY + 75 + levelH - levelP,
																   levelW,		levelP);
			this.backBufferContext2D.fillStyle = "White";
			this.backBufferContext2D.font = "22px Arial";
//            console.log(levelX + " | " + levelY);
			this.backBufferContext2D.fillText(text[l][60], levelX + 88, levelY + 22);
			this.backBufferContext2D.fillText(level + "/12", levelX + 88, levelY + 47);
		}
			
		//draw score board
//		this.backBufferContext2D.drawImage(imgSCORE, scoreX,	scoreY);
            this.backBufferContext2D.translate(scoreX, scoreY);
            this.backBufferContext2D.drawImage(imgSCORE, 0,	0);
            this.backBufferContext2D.translate(-scoreX, -scoreY);
		
		//draw score
		//		this.backBufferContext2D.globalAlpha = 0.85;
		this.backBufferContext2D.font = "32px Arial";
//		this.backBufferContext2D.fillText(window.innerHeight, pointsX, pointsY);		
		this.backBufferContext2D.fillText(levelScore.toString(10), pointsX, pointsY);		
			this.backBufferContext2D.font = "12px Arial";
			this.backBufferContext2D.fillText(text[l][59], pointsX-52, pointsY + 62);
			this.backBufferContext2D.font = "22px Arial";
			this.backBufferContext2D.textAlign = "left";
			this.backBufferContext2D.fillText(highscore.toString(10), pointsX-7, pointsY + 60);
			if (points.move) this.drawPoints(points.value);
			this.backBufferContext2D.textAlign = "center";
		
		//draw stones
		for (var i=0; i<stoneN; i++)
			if (stone[i].move){
//				if (stone[i].x < 70) this.backBufferContext2D.globalAlpha = (stone[i].x - 35) / 35;
				this.backBufferContext2D.translate(stone[i].x, stone[i].y);

				if (stone[i].group < 16)	this.backBufferContext2D.drawImage(imgSTONEa[stone[i].group], 0,	0);
				else 						this.backBufferContext2D.drawImage(imgSTONE[stone[i].group], 0,	0);

				this.backBufferContext2D.translate(-stone[i].x, -stone[i].y);
//				this.backBufferContext2D.globalAlpha = 1;
				
			}
		
		//draw titles
		if (tit.t) {
			this.backBufferContext2D.translate(tit.x - tit.w2, tit.y - tit.h2);
			this.backBufferContext2D.globalAlpha = tit.fade;
			this.backBufferContext2D.drawImage(imgTITLE1, 0,	0);
			this.backBufferContext2D.fillStyle = "#58585a";
			this.backBufferContext2D.font = "22px Arial";
			switch (gameMode) {
				case 10:
					switch (tit.task){
						case 0: case 1:	this.backBufferContext2D.fillText(text[l][2], tit.w2, tit.h2 + 30); break;
						case 2: case 3: case 4:
										this.backBufferContext2D.fillText(text[l][4], tit.w2, tit.h2 + 25);	
										this.backBufferContext2D.fillText(tit.s, tit.w2, tit.h2 + 55); break;	
						case 5: case 6: this.backBufferContext2D.fillText(tit.s, tit.w2, tit.h2 + 30); break;
						default:
							break;
					}
					break;
				case 11:
					this.backBufferContext2D.fillText(text[l][5], tit.w2, tit.h2 + 30);
					break;
				default:
					break;
			}
			this.backBufferContext2D.globalAlpha = 1;
			this.backBufferContext2D.translate(-tit.x + tit.w2, -tit.y + tit.h2);
		}
		
		//draw buttons: pause
		if (button[10].on)	this.backBufferContext2D.drawImage(imgBUTPAUS2, button[10].x, button[10].y);
			else			this.backBufferContext2D.drawImage(imgBUTPAUS1, button[10].x, button[10].y);


		this.backBufferContext2D.fillStyle = "#58585a";
		if (menu.on) {
			this.backBufferContext2D.globalAlpha = menu.globalFade;
            this.backBufferContext2D.drawImage(imgMAINMENU, 0,	0);
/*
			this.backBufferContext2D.fillStyle = "#58585a"
			var buttons = 4;
			if (ranking) buttons = 5;
			for (var i=0; i<buttons; i++){
				if (button[i].on)	{this.backBufferContext2D.drawImage(imgBUTMENU2, button[i].x, button[i].y); this.backBufferContext2D.font = "22px Arial";}
				else			{this.backBufferContext2D.drawImage(imgBUTMENU1, button[i].x, button[i].y); this.backBufferContext2D.font = "22px Arial";}
				switch (i) {
					case 3: 
						if (button[i].on) this.backBufferContext2D.font = "22px Arial";
						else this.backBufferContext2D.font = "22px Arial";
//						this.backBufferContext2D.fillText(text[l][26], button[i].x + menu.buttW2, button[i].y + menu.buttH2);
						this.drawText(text[l][26], button[i].x + menu.buttW2 + 2, button[i].y + menu.buttH2 - 3, 24, 0, 8);
						break;
					case 4:
						if (button[i].on) this.backBufferContext2D.font = "22px Arial";
						else this.backBufferContext2D.font = "22px Arial";
						this.backBufferContext2D.fillText(text[l][9], button[i].x + menu.buttW2, button[i].y + menu.buttH2 - 6);
						this.backBufferContext2D.fillText(text[l][10], button[i].x + menu.buttW2, button[i].y + menu.buttH2 + 8);
						break;
					default:
						this.backBufferContext2D.fillText(text[l][6+i], button[i].x + menu.buttW2, button[i].y + menu.buttH2);
						break;
				}
			}
*/

			switch (gameMode){
				case 16:	//game start screen
					this.backBufferContext2D.globalAlpha = menu.fade;
					this.backBufferContext2D.drawImage(imgPOUPUP, 0, 0);
					
					this.backBufferContext2D.drawImage(imgMENUPLAY, menu.playX - menu.playX2, menu.playY - menu.playY2);


					this.backBufferContext2D.font = "italic 30px Arial";
					this.backBufferContext2D.fillStyle = "#FFF";
                    if (!inputMark) this.backBufferContext2D.fillText(playerName, menu.playX + 3, menu.playY + 127); 


/*                     this.backBufferContext2D.drawImage(imgK2, menu.playX - menu.k2W2, menu.playY + 20); */
                    
					this.backBufferContext2D.font = "bold 30px Arial";
					this.backBufferContext2D.fillStyle = "58585a";
					this.backBufferContext2D.textAlign = "center"
                    this.drawText(text[l][20],  menu.playX, menu.playY, /*linespace*/25 , /*lines*/6, 50);
					
					this.backBufferContext2D.globalAlpha = 1;
					break;
				case 17:
					this.backBufferContext2D.globalAlpha = menu.fade;
					this.backBufferContext2D.drawImage(imgMENULANG, menu.langX - menu.langW2, menu.langY - menu.langH2);
					
					this.backBufferContext2D.fillStyle = "#58585a";
					if (button[18].on) {this.backBufferContext2D.font = "15px Arial"; this.backBufferContext2D.drawImage(imgBUTMENU2, button[18].x, button[18].y);}
					else {this.backBufferContext2D.font = "16px Arial";	this.backBufferContext2D.drawImage(imgBUTMENU1, button[18].x, button[18].y);}
					this.backBufferContext2D.fillText(text[l][14], button[18].x + menu.buttW2, button[18].y + menu.buttH2);
					this.backBufferContext2D.font = "16px Arial";
					for (var i=0; i<languages; i++){
						if (i == l)	 {
							this.backBufferContext2D.fillStyle = "#58585a"; 
							this.backBufferContext2D.fillText("- " + text[i][0] + " -", menu.langX, button[19+i].y);
						}
						else {
							this.backBufferContext2D.fillStyle = "#58585a";
							this.backBufferContext2D.fillText(text[i][0], menu.langX, button[19+i].y);
						}
						if (i != languages - 1) this.backBufferContext2D.drawImage(imgK1, menu.langX - menu.k1W1, button[19+i].y + 14);
					}
					
					break;
			}
			this.backBufferContext2D.globalAlpha = 1;
		}
		
		
	switch(gameMode){
		case 18: //OPTIONS MENU
			this.backBufferContext2D.globalAlpha = menu.fade;
			this.backBufferContext2D.drawImage(imgMENUOPTI, menu.optiX - menu.optiX2, menu.optiY - menu.optiY2);
			console.log(menu.optiX +"-"+ menu.optiX2);
			this.backBufferContext2D.font = "15px Arial";
			for (var i=0; i<3; i++){
				if (button[5+i].on)	 {
					this.backBufferContext2D.fillStyle = "#58585a"; 
					this.backBufferContext2D.fillText("- " + text[l][11+i] + " -", menu.optiX, button[5+i].y);
				}
				else {
					this.backBufferContext2D.fillStyle = "#58585a";
					this.backBufferContext2D.fillText(text[l][11+i], menu.optiX, button[5+i].y);
				}
				this.backBufferContext2D.drawImage(imgK1, menu.optiX - menu.k1W1, button[5+i].y + 13);
				
			}
			

			this.backBufferContext2D.fillStyle = "#58585a";
			if (button[8].on) {this.backBufferContext2D.font = "22px Arial"; this.backBufferContext2D.drawImage(imgBUTMENU2, menu.optiX - menu.buttW2, button[8].y);}
			else {this.backBufferContext2D.font = "22px Arial";	this.backBufferContext2D.drawImage(imgBUTMENU1, menu.optiX - menu.buttW2, button[8].y);}

			this.backBufferContext2D.fillText(text[l][14], menu.optiX, button[8].y + menu.buttH2);
			this.backBufferContext2D.globalAlpha = 1;
			break;
		case 19: //PAUSE MENU
			this.backBufferContext2D.globalAlpha = menu.fade;
			this.backBufferContext2D.drawImage(imgPOUPUP, 0, 0);			
			this.backBufferContext2D.drawImage(imgNOTICEB2, menu.noticeb1X - menu.noticeb1W2, menu.noticeb1Y - menu.noticeb1H2);
			this.backBufferContext2D.globalAlpha = 1;			
			break;
		case 20: //HELP 
			this.backBufferContext2D.globalAlpha = menu.fade;
			this.backBufferContext2D.drawImage(imgPOUPUP, 0, 0);			
			this.backBufferContext2D.drawImage(imgMENUPLAY, menu.helpX - menu.playX2, menu.helpY - menu.playY2);
			this.backBufferContext2D.drawImage(imgTUT1, menu.helpX - menu.playX2 + 70, menu.helpY - menu.playY2 + 190);
			this.backBufferContext2D.font = "16px Arial";
			this.backBufferContext2D.fillStyle = "58585a";
			this.backBufferContext2D.textAlign = "left"
			switch (helpScreen){
				case 0: 
					this.wrapText(text[l][23], menu.helpX - 265, menu.helpY - 60, 550, 20);
/*
					this.wrapText(text[l][24], menu.helpX - 265, menu.helpY - 15, 580, 24);
					this.wrapText(text[l][25], menu.helpX - 265, menu.helpY + 15, 580, 24);
*/
					this.wrapText(text[l][26], menu.helpX - 265, menu.helpY + 210, 540, 20);
					break;
			}
			this.backBufferContext2D.globalAlpha = 1;
			break;
		case 21:
			this.backBufferContext2D.globalAlpha = menu.fade; 
			this.backBufferContext2D.fillStyle = "#58585a";
//            console.log("noticeBox: " + noticeBox);
			switch (noticeBox) {
				case 0: //level complete; level x
					this.backBufferContext2D.drawImage(imgNOTICEB1, menu.noticeb1X - menu.noticeb1W2, menu.noticeb1Y - menu.noticeb1H2);
					this.backBufferContext2D.font = "bold 24px Arial";
					if (level == 13)	this.backBufferContext2D.fillText(text[l][28], menu.noticeb1X, menu.noticeb1Y - 15);
					else				this.backBufferContext2D.fillText(text[l][27], menu.noticeb1X, menu.noticeb1Y - 15);
					this.backBufferContext2D.drawImage(imgNOTICEBK1, menu.noticeb1X - menu.noticebK1W2, menu.noticeb1Y + 5);
					this.backBufferContext2D.font = "16px Arial";
					this.backBufferContext2D.fillText(text[l][29], menu.noticeb1X, menu.noticeb1Y + 35);
					this.backBufferContext2D.font = "20px Arial";
					this.backBufferContext2D.fillText(highscore, menu.noticeb1X, menu.noticeb1Y + 60);
					break;
				case 1: //barometer notice
					this.backBufferContext2D.drawImage(imgNOTICEB1, menu.noticeb1X - menu.noticeb1W2, menu.noticeb1Y - menu.noticeb1H2);
					this.backBufferContext2D.drawImage(imgPLATE,  menu.noticeb1X - plateX2, menu.noticeb1Y - 55);
					this.backBufferContext2D.font = "10px Arial";
					if (level == 5) {
						this.backBufferContext2D.drawImage(imgSTONE2, menu.noticeb1X - plateX2, menu.noticeb1Y - 55);
						this.backBufferContext2D.fillText(text[l][30], menu.noticeb1X, menu.noticeb1Y + 2);
						this.drawText(text[l][32], menu.noticeb1X, menu.noticeb1Y + 22, 12, 0, 25);
					}
					else {
						this.backBufferContext2D.drawImage(imgSTONE3, menu.noticeb1X - plateX2, menu.noticeb1Y - 55);
						this.backBufferContext2D.fillText(text[l][31], menu.noticeb1X, menu.noticeb1Y + 2);
						this.drawText(text[l][33], menu.noticeb1X, menu.noticeb1Y + 22, 12, 0, 25);
					}
					this.backBufferContext2D.drawImage(imgNOTICEBK1, menu.noticeb1X - menu.noticebK1W2, menu.noticeb1Y + 10);
					this.backBufferContext2D.translate(arrow.x, arrow.y);
					this.backBufferContext2D.rotate(PI2 * .125);
					this.backBufferContext2D.drawImage(imgBUTNEXT, arrow.add, 0);
					this.backBufferContext2D.rotate(-PI2 * .125);					
					this.backBufferContext2D.translate(-arrow.x, -arrow.y);
					break;
				case 2: case 3: case 4://quiz: 2-before answer, 3-answer chosen, 4-result shown and next button
					this.backBufferContext2D.drawImage(imgMENUQUEST, 0, 0);
					this.backBufferContext2D.fillStyle = "#58585a";
					this.backBufferContext2D.textAlign = "center";
					this.backBufferContext2D.font = "bold 28px Arial";
					var tekst = (questToAsk+1) + "/4";
					this.backBufferContext2D.fillText(tekst, 207, 116);
					this.backBufferContext2D.fillStyle = "#6d6e71";
					this.backBufferContext2D.textAlign = "center";
					this.backBufferContext2D.font = "bold 28px Arial";
					var tekst = categoryName[questToAsk];
					this.backBufferContext2D.fillText(tekst, 430, 116);

					this.backBufferContext2D.textAlign = "left";
					switch (noticeBox) {
						case 3:
							var blink = timer;
							while (blink > 200) {blink -=200;}
							if (blink < 100) this.backBufferContext2D.drawImage(imgQUESTA, 111, 380 + answered*98);
							break;
						case 4:
							if (!answersRnd[answered]) { //correctly answered
								this.backBufferContext2D.drawImage(imgQUESTC, 111, 380 + answered*98);
							} else { //incorrect answer
								for (var i=0; i<answersRnd.length; i++) if (!answersRnd[i]) break;
								this.backBufferContext2D.drawImage(imgQUESTI, 111, 380 + answered*98);
								this.backBufferContext2D.drawImage(imgQUESTC, 111, 380 + i*98);
							
							}
							this.backBufferContext2D.drawImage(imgBUTNEXT, 374, 800);
							break;
					}

					
					this.backBufferContext2D.textAlign = "center";
					this.backBufferContext2D.font = "bold 40px Arial";
					
					var answers;
					if (pytania[questToAsk][question * 6 + 4].length) answers = 4; else answers = 3;
					for (var i=0; i<answers; i++) {
						if (noticeBox == 4 && i == answered && answersRnd[answered]) this.backBufferContext2D.fillStyle = "#fff"; else this.backBufferContext2D.fillStyle = "#ed217c";
						this.backBufferContext2D.fillText(String.fromCharCode(65+i), 160, 425 + i*98);
					}

					if (noticeBox == 4 && answersRnd[answered]) {
						this.backBufferContext2D.fillStyle = "#fff";					
					}
	
					this.backBufferContext2D.fillStyle = "#6d6e71";
					this.backBufferContext2D.textAlign = "left";
					this.backBufferContext2D.font = "18px Arial";
/* 					console.log(questToAsk + ", " + question); */
					var lines;
					var metrics;
					metrics = this.backBufferContext2D.measureText(pytania[questToAsk][question * 6]);
					lines = Math.floor(metrics.width / 505) + 1;
					this.wrapText(pytania[questToAsk][question * 6], 126, 368 - 32 * lines, 505, 28);
					for (var i=0; i<4; i++) {
				          metrics = this.backBufferContext2D.measureText(pytania[questToAsk][question*6+answersRnd[i]+1]);
				          lines = Math.floor(metrics.width / 410) + 1;
						this.wrapText(pytania[questToAsk][question*6+answersRnd[i]+1], 212, 436 + i*98 - 11 * lines, 410, 22);
					}
/*
					this.backBufferContext2D.fillStyle = "#FFF";					
					this.backBufferContext2D.textAlign = "center";
					this.backBufferContext2D.fillText(text[l][gameMode], 450, 827);
*/

					break;
/*
				case 3:
					this.backBufferContext2D.drawImage(imgNOTICEB2, menu.noticeb2X - menu.noticeb2W2, menu.noticeb2Y - menu.noticeb2H2);
					this.backBufferContext2D.font = "10px Calibri";
					this.backBufferContext2D.fontStyle = "italic";
					if (level)	this.drawText(text[l][54], menu.noticeb1X, menu.noticeb1Y - 14, 12, 0, 28);
						else	this.drawText(text[l][52], menu.noticeb1X, menu.noticeb1Y - 26, 12, 0, 28);

					this.backBufferContext2D.fontStyle = "normal";
					break;
*/

			}
				
				this.backBufferContext2D.globalAlpha = 1;
			break;
	}

	//DRAW ENDS	
	// copy the back buffer to the displayed canvas
//	this.context2D.drawImage(this.backBuffer, 0, 0);
		this.backBufferContext2D.restore();
	
		}
};	//draw function
	
	this.drawAnim = function (y, x)
	{
/*
		this.backBufferContext2D.translate(animDustXc,  animDustYc	+ (table[y][x][3] - 1) * 22);
		var	fade, blend = y * (plateX - plateYfix) + (table[y][x][3] - 1) * 22;
		if (blend > 200) {
			if (table[y][x][7]) table[y][x][7] = false;
			fade = true; 
			blend = (260 - blend) / 50; 
			if (blend > 0) this.backBufferContext2D.globalAlpha = blend; else this.backBufferContext2D.globalAlpha = 0;
		}
		if (fade) this.backBufferContext2D.globalAlpha = 1;
		this.backBufferContext2D.translate(-animDustXc, -animDustYc - (table[y][x][3] - 1) * 22);
*/

		this.backBufferContext2D.drawImage(imgEXPL,		animExplX	* (table[y][x][3] - 1), 0, animExplX, animExplY, 0, -20, animExplX, animExplY);

	}
	
	this.drawPlate = function (y, x, notAnimated)
	{
		if ( (!table[y][x][4] && notAnimated) || (table[y][x][4] && !notAnimated) )
		{
			
			this.backBufferContext2D.translate(0, -table[y][x][4] - 10);
				//draw hands
				for (var k=0; k < 2; k++) {
					if (field[y][x] > 1) this.backBufferContext2D.globalAlpha = 1 - platesFade;

					this.backBufferContext2D.translate(plateX2, plateX2);
					this.backBufferContext2D.rotate(PI2/360 * (table[y][x][k]));
					this.backBufferContext2D.translate(-plateX2, -plateX2);
/*
					if (rot.dir && rot.x == x && rot.y == y) this.backBufferContext2D.drawImage(imgBACKLIG2, 0,	0);
					else if (active[y][x] == 2) this.backBufferContext2D.drawImage(imgBACKLIGHT2, 0,	0);
*/
					this.backBufferContext2D.drawImage(imgHAND, 0,	0); //if not a start||end = one hand
					if (active[y][x]) this.backBufferContext2D.drawImage(imgHANDa, 0,	0);
					this.backBufferContext2D.translate(plateX2, plateX2);
					this.backBufferContext2D.rotate(-PI2/360 * (table[y][x][k]));
					this.backBufferContext2D.translate(-plateX2, -plateX2);
					if (field[y][x] == 3) break; //if it's a start||end, don't draw second hand
				}
				
				//draw plates
/*
				if (rot.dir && rot.x == x && rot.y == y) this.backBufferContext2D.drawImage(imgBACKLIG, 0,	0);
				else 
*/
/* 				if (field[y][x] > 1 && active[y][x] == 2) 	this.backBufferContext2D.drawImage(imgSTONEa[table[y][x][8]], 0,	0); */
				if (active[y][x]){
					
					switch(field[y][x]){
						case 1: 
							this.backBufferContext2D.save();
							this.backBufferContext2D.translate(plateX2, plateX2);
							this.backBufferContext2D.rotate(table[y][x][2]); 
							this.backBufferContext2D.translate(-plateX2, -plateX2);
							this.backBufferContext2D.drawImage(imgSCARAB, 0,	0);	
							this.backBufferContext2D.restore();

							break;
						case 2: 
							this.backBufferContext2D.drawImage(imgPLATE, 0,	0);
							if (active[y][x] == 2) {
								if (table[y][x][8] < 16)	this.backBufferContext2D.drawImage(imgSTONEa[table[y][x][8]],	0,	0);
								else						this.backBufferContext2D.drawImage(imgSTONE[table[y][x][8]],	0,	0);
							} else this.backBufferContext2D.drawImage(imgSTONE[table[y][x][8]],	0,	0);

							this.backBufferContext2D.save();
							this.backBufferContext2D.translate(plateX2, plateX2);
							this.backBufferContext2D.rotate(PI2/360 * (table[y][x][0]));
							this.backBufferContext2D.translate(-plateX2, -plateX2);
							this.backBufferContext2D.drawImage(imgPLATEa, 0,	0);	
							this.backBufferContext2D.restore();

							break;
						case 3: 
								this.backBufferContext2D.drawImage(imgPLATEEND, 0,	0);
							break;
					}
				}
				else {
					switch(field[y][x]){
						case 1: 
							this.backBufferContext2D.save();
							this.backBufferContext2D.translate(plateX2, plateX2);
							this.backBufferContext2D.rotate(table[y][x][2]); 
							this.backBufferContext2D.translate(-plateX2, -plateX2);
							this.backBufferContext2D.drawImage(imgSCARAB, 0,	0);	
							this.backBufferContext2D.restore();
							break;
						case 2: 
							this.backBufferContext2D.drawImage(imgPLATE, 0,	0);
							this.backBufferContext2D.drawImage(imgSTONE[table[y][x][8]], 0,	0);
							break;
						case 3: 
							this.backBufferContext2D.drawImage(imgPLATEEND, 0,	0);
							break;
					}
				}
			this.backBufferContext2D.globalAlpha = 1;	
			this.backBufferContext2D.translate(0, table[y][x][4] + 10);
		}
	}
	
	this.drawPoints = function(p)
	{
		var txt = new String(p);
		var len = txt.length;
//		console.log(p + " | len: " + len);
//		var x, xlen;
		this.backBufferContext2D.save();
		this.backBufferContext2D.translate(points.x - len * point[2][1] / 2, points.y - pointY2);
		if (points.y < scoreY + 32 + pointsYport) this.backBufferContext2D.globalAlpha = (points.y - scoreY - 12 - pointsYport) / 20;
		
		for (var i=0; i<len; i++) {
			this.backBufferContext2D.drawImage(imgPOINTS, point[txt[i]][0], 0, point[txt[i]][1], pointY, 0, 0, point[txt[i]][1], pointY);
			this.backBufferContext2D.translate(point[txt[i]][1], 0);
		}
		
		this.backBufferContext2D.restore();
	}
	
	this.drawText = function(txt, a, b, leading, line, stop2)
	{
		var n = 0, x = 0, y = 0, str, ch, len = txt.length, stop = 38;
		do {
			str = "";
/* 			if (y == line) stop = stop2; */
			do {
				ch = txt.charAt(n);
				str += ch;
				n++; x++;
			} while (x < stop2 || ch != " " && n < len);
//			console.log(str);
			this.backBufferContext2D.fillText(str, a, b + y * leading);
			y++; x = 0; 
		} while (n < len);
		lastTextRows = y;
	}
	
    this.wrapText = function(text, x, y, maxWidth, lineHeight) 
    {
		var words = text.split(' ');
        var line = '';
        for(var n = 0; n < words.length; n++) {
          var testLine = line + words[n] + ' ';
          var metrics = this.backBufferContext2D.measureText(testLine);
          var testWidth = metrics.width;
          if (testWidth > maxWidth && n > 0) {
            this.backBufferContext2D.fillText(line, x, y);
            line = words[n] + ' ';
            y += lineHeight;
          }
          else {
            line = testLine;
          }
        }
        this.backBufferContext2D.fillText(line, x, y);
	}
	
      
}

